package DnDCharacterGenerator.DiceAndStuff;

import java.util.Arrays;

public class StatGenerator {

    private DiceRoller dRoller;

    StatGenerator() {
        this(new DiceRoller());
    }

    StatGenerator(long seed) {
        this(new DiceRoller(seed));
    }

    StatGenerator(DiceRoller seed) {
        this.dRoller = seed;
    }
    
    /**
     * Generates array of 6 ability scores or "stats".
     * Each stat is generated by rolling 4 6 sided dice (also known as 4d6), summing them together and taking away the lowest resault. (4d6 pick the 3 highest)
     * 
     * @return array of 6 integers between 3 and 18
     */
    int[] generateStatArray() {
        int[] stats = new int[6];
        int[] currentRolls;
        //int roll4;
        int totalRoll;

        for (int i = 0; i < stats.length; i++) {
            totalRoll = 0;
            
            currentRolls = dRoller.rollXdYseperate(4, 6); // roll 4 dice seperated in an array
            Arrays.sort(currentRolls); // sort the 4 rolled dice from lowest to heighest
            
            for (int j = 1; j < currentRolls.length; j++) { // sum the rolls toghether skipping the first index due to it being the lowest
                totalRoll += currentRolls[j];
            }
            stats[i] = totalRoll; // put in the array after
        }
        
        return stats;
    }

    /**
     * Generates the stat array known as "standard array", which is {15, 14, 13, 12, 10, 8}.
     * This stat array is more balanced that the array generated by generateStatArray() due to not being randomly generated.
     * 
     * @return {15, 14, 13, 12, 10, 8}
     */
    int[] generateStandardArray() {
        int[] standardArray = {15, 14, 13, 12, 10, 8};
        return standardArray;
    }

    /**
     * Generates an array of 6 zeros.
     * 
     * @return array of 6 zeros
     */
    int[] generateZeroArray() {
        int[] zeros = {0, 0, 0, 0, 0, 0};
        return zeros;
    }

}
